﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Infragistics.Controls.Editors;
using Infragistics.Controls.Grids;

namespace CustomComboEditorColumn
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
        }


        private void xamGrid_CellEnteredEditMode(object sender, EditingCellEventArgs e)
        {
            if (e.Cell.Column.Key == "SelectedValue")
            {
                XamComboEditor box = e.Editor as XamComboEditor;
                if (box != null)
                {
                    Binding b = new Binding
                                    {
                                        Source = e.Cell.Row.Data,
                                        Path = new PropertyPath("Values"),
                                    };
                    box.ClearValue(XamComboEditor.ItemsSourceProperty);
                    box.SetBinding(XamComboEditor.ItemsSourceProperty, b);

                    Binding selectedItemBinding = new Binding
                                                      {
                                                          Source = e.Cell.Row.Data,
                                                          Path = new PropertyPath(e.Cell.Column.Key),
                                                          Mode = BindingMode.TwoWay,
                                                          ValidatesOnNotifyDataErrors = true,
                                                          NotifyOnValidationError = true,
                                                      };

                    box.ClearValue(XamComboEditor.SelectedItemProperty);
                    box.SetBinding(XamComboEditor.SelectedItemProperty, selectedItemBinding);
                }
            }
        }

        private void xamGrid_CellExitingEditMode(object sender, ExitEditingCellEventArgs e)
        {
            if ((e.Cell.Column.Key == "SelectedValue") && (!e.EditingCanceled))
            {
                CustomXamCombooEditor box = e.Editor as CustomXamCombooEditor;

                if (box != null)
                {
                    if (box.SelectedItem != null)
                    {
                        e.NewValue = box.SelectedItem;
                    }
                }
            }
        }


        private void xamGrid_ActiveCellChanged(object sender, EventArgs e)
        {
            if ((xamGrid == null) || (xamGrid.ActiveCell == null) || (xamGrid.ActiveCell.Row == null) || (xamGrid.Columns == null) ||
                (xamGrid.Columns.AllVisibleChildColumns == null) || (xamGrid.Columns.AllVisibleChildColumns["SelectedValue"] == null)
                || (xamGrid.Rows[xamGrid.ActiveCell.Row.Index] == null) || (xamGrid.Rows[xamGrid.ActiveCell.Row.Index].Cells == null) ||
                    (xamGrid.Rows[xamGrid.ActiveCell.Row.Index].Cells[xamGrid.Columns.AllVisibleChildColumns["SelectedValue"]] == null))
            {
                return;
            }

            if (!xamGrid.Rows[xamGrid.ActiveCell.Row.Index].Cells[xamGrid.Columns.AllVisibleChildColumns["SelectedValue"]].IsActive)
            {
                xamGrid.Rows[xamGrid.ActiveCell.Row.Index].Cells[xamGrid.Columns.AllVisibleChildColumns["SelectedValue"]].IsActive = true;
            }
        }


    }
}
